package cat.hack3.codingtests.marsrover.test.context;

import cat.hack3.codingtests.marsrover.api.commands.RoverCommand;
import cat.hack3.codingtests.marsrover.api.commands.RoverCommandFactory;

public class GivenRotableAndMoveCommandsOnDeployedRoverWithMap extends GivenMarsRoverDeployedOnMarsMap {

    public static final Class<RoverCommandFactory.Provider> COMMAND_FACTORY_PROVIDER = RoverCommandFactory.Provider.class;
    protected RoverCommand moveForwardCommand;
    protected RoverCommand moveBackwardsCommand;
    protected RoverCommand turnLeftCommand;
    protected RoverCommand turnRightCommand;

    public void setUp() {
        super.setUp();
        RoverCommandFactory commandFactory = getImplProviderOf(COMMAND_FACTORY_PROVIDER)
                .provideWith(rover);

        moveForwardCommand = commandFactory.create("MOVE_FORWARD");
        moveBackwardsCommand = commandFactory.create("MOVE_BACKWARDS");
        turnLeftCommand = commandFactory.create("TURN_LEFT");
        turnRightCommand = commandFactory.create("TURN_RIGHT");
    }
}
